
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android下实现非启动界面Wifi连接 / iVAN</title>

    <meta name="description" content="Android下实现非启动界面Wifi连接 Android的网络功能和一般的linux并无太大的区别,我原来以为在Android上连接网络和普通的linux连接网络没有很大区别,事实上区别还是有一些的. 由于项目的需要,我的目标是在Android的界面没有启动之前连接wifi,于是本来的期待是直接在init.rc中加入一些脚本调用即可,但研究了一会儿发现没有那么简单. 首先要感谢anly_jun@baidu贴吧的几篇博文,从http://hi.baidu.com/anly_jun/blog/item/8ecb92d593d144cf50d">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android下实现非启动界面Wifi连接</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Android的网络功能和一般的linux并无太大的区别，我原来以为在Android上连接网络和普通的linux连接网络没有很大区别，事实上区别还是有一些的。</p>
<p>由于项目的需要，我的目标是在Android的界面没有启动之前连接wifi，于是本来的期待是直接在init.rc中加入一些脚本调用即可，但研究了一会儿发现没有那么简单。</p>
<p>首先要感谢<a href="http://yangyangzhao.blog.163.com/blog/static/175816366201011412949131/anly_jun@baidu" rel="external nofollow noreferrer">anly_jun@baidu</a>贴吧的几篇博文，从<a href="http://hi.baidu.com/anly_jun/blog/item/8ecb92d593d144cf50da4b6e.html" rel="external nofollow noreferrer">http://hi.baidu.com/anly_jun/blog/item/8ecb92d593d144cf50da4b6e.html</a>开始，一共有七篇关于Android<br />
 Wifi模块分析，其中有大量博主自己使用UML工具画的调用讲解，对于理解Android Wifi工作机制还是有很用的。其中最重要的是下面这几幅图。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuMTYzLmNvbS9waG90by8ySEhMVjNlZHRzYm5XbDVPa0czVVRnPT0vNTcyMjY2Nzc1MTUwNDg1OTc4Ni5qcGc=.jpg">（转自<a href="http://hi.baidu.com/anly_jun/blog/item/65e26e117e09ebcda6ef3f56.html" rel="external nofollow noreferrer">http://hi.baidu.com/anly_jun/blog/item/65e26e117e09ebcda6ef3f56.html</a>）</p>
<p>在想要对wifi硬件动作之前，需要做两件事情，一是要load wifi的driver，而是要打开wpa_supplicant，其实如果是连接没有加密的wifi，没有必要打开wpa_supplicant，但是为了讲问题化为熟知的问题，此处还是先按照提示调用wifi_load_driver()和wifi_start_supplicant()</p>
<p>按照上面的提示写出来的初始化代码如下：</p>
<p><strong>int</strong> init_stage() { <br />    <em>//<br />
 load the wifi driver: insmod .ko</em> <br />    <strong>int</strong> ret = wifi_load_driver(); <br />    <strong>if</strong>(ret &lt; 0) { <br />        LOGE("Failed<br />
 to load Wi-Fi driver. %s",strerror(errno)); <br />        <strong>return</strong> -1; <br />    } </p>
<p>    <em>//<br />
 start wpa_supplicant</em> <br />    ret =  wifi_start_supplicant(); <br />    <strong>if</strong>(ret &lt; 0) { <br />        LOGE("Failed<br />
 to start supplicant daemon. %s",strerror(errno)); <br />        <strong>return</strong> -1; <br />    } <br />    <strong>return</strong> 0; <br />} </p>
<p>接下来，便是连接的过程了，经过上面的步骤，wifi的driver已经载入，wpa_supplicant也已经打开，那咱们就可以开始连接无线了吧。后来证实这是错误的，因为anly_jun的这篇Android wifi分析的粒度只在Java层面的函数级别，因此有一些细节并没有提到。在下面我会提到这些细节。</p>
<p>按照一般的linux中连接wifi的步骤，这时候就可以直接调用一个程序来连接某个ssid的无线网络，然后调用dhcpd来分配ip了，我之前在eeepc上连接wifi就非常简单，调用iwconfig [ssid]，再调用dhcpd就可以了。但很遗憾，Android上并没有iwconfig这样方便的工具。</p>
<p>这下线索似乎就断了，天无绝人之路，既然在Android的Java code中都可以添加一个无线网络并且连接，那我们就去Android的Java源代码中找一找。在Android中，程序员是使用WifiManager这个类来进行Wifi操作的，其中关于添加一个网络的代码如下：</p>
<p><em>/**</em> <br /><em>* Add a new network description to the set of configured networks.</em> <br /><em>* The {@code networkId} field of the supplied configuration object</em> <br /><em>* is ignored.</em> <br /><em>* &lt;p/&gt;</em> <br /><em>* The new network will be marked DISABLED by default. To enable it,</em> <br /><em>* called {@link #enableNetwork}.</em> <br /><em>*</em> <br /><em>* @param config the set of variables that describe the configuration,</em> <br /><em>*            contained in a {@link WifiConfiguration} object.</em> <br /><em>* @return the ID of the newly created network description. This is used in</em> <br /><em>*         other operations to specified the network to be acted upon.</em> <br /><em>*         Returns {@code -1} on failure.</em> <br /><em>*/</em> <br /><strong>public</strong> <strong>int</strong> addNetwork(WifiConfiguration config) { <br />
    <strong>if</strong> (config == <strong>null</strong>) { <br />
        <strong>return</strong> -1; <br />
    } <br />
    config.networkId = -1; <br />
    <strong>return</strong> addOrUpdateNetwork(config); <br />
} </p>
<p><em>/**</em> <br /><em>* Internal method for doing the RPC that creates a new network description</em> <br /><em>* or updates an existing one.</em> <br /><em>*</em> <br /><em>* @param config The possibly sparse object containing the variables that</em> <br /><em>*         are to set or updated in the network description.</em> <br /><em>* @return the ID of the network on success, {@code -1} on failure.</em> <br /><em>*/</em> <br /><strong>private</strong> <strong>int</strong> addOrUpdateNetwork(WifiConfiguration config) { <br />
    <strong>try</strong> { <br />
        <strong>return</strong> mService.addOrUpdateNetwork(config); <br />
    } <strong>catch</strong> (RemoteException e) { <br />
        <strong>return</strong> -1; <br />
    } <br />
} </p>
<p>看其中确实是调用了service的函数，于是又在frameworks/base/services/java/com/android/server/WifiService.java中找到了有关增加一个网络配置的相关代码</p>
<p><em>/**</em> <br /><em>* see {@link android.net.wifi.WifiManager#addOrUpdateNetwork(WifiConfiguration)}</em> <br /><em>* @return the supplicant-assigned identifier for the new or updated</em> <br /><em>* network if the operation succeeds, or {@code -1} if it fails</em> <br /><em>*/</em> <br /><strong>public</strong> <strong>int</strong> addOrUpdateNetwork(WifiConfiguration config) { <br />
    enforceChangePermission(); </p>
<p>    <em>/*</em> <br /><em>     * If the supplied networkId is -1, we create a new empty</em> <br /><em>     * network configuration. Otherwise, the networkId should</em> <br /><em>     * refer to an existing configuration.</em> <br /><em>     */</em> <br />
    <strong>int</strong> netId = config.networkId; <br />
    <strong>boolean</strong> newNetwork = netId == -1; <br />
    <strong>boolean</strong> doReconfig = <strong>false</strong>; <br />
    <em>// networkId of -1 means we want to create a new network</em><br />
    <strong>synchronized</strong> (mWifiStateTracker) { <br />
        <strong>if</strong> (newNetwork) { <br />
            netId = mWifiStateTracker.addNetwork(); <br />
            <strong>if</strong> (netId &lt; 0) { <br />
                <strong>if</strong> (DBG) { <br />
                    Slog.d(TAG, "Failed to add a network!");<br />
                } <br />
                <strong>return</strong> -1; <br />
            } <br />
            doReconfig = <strong>true</strong>; <br />
        } <br />
        mNeedReconfig = mNeedReconfig || doReconfig; <br />
    } </p>
<p>    setVariables: { <br />
        <em>/*</em> <br /><em>         * Note that if a networkId for a non-existent network</em> <br /><em>         * was supplied, then the first setNetworkVariable()</em><br /><em>         * will fail, so we don't bother to make a separate check</em> <br /><em>         * for the validity of the ID up front.</em> <br /><em>         */</em> <br />
        <strong>if</strong> (config.SSID != <strong>null</strong> &amp;&amp; <br />
                !mWifiStateTracker.setNetworkVariable( <br />
                    netId, <br />
                    WifiConfiguration.ssidVarName, <br />
                    config.SSID)) { <br />
            <strong>if</strong> (DBG) { <br />
                Slog.d(TAG, "failed to set SSID: "+config.SSID); <br />
            } <br />
            <strong>break</strong> setVariables; <br />
        } </p>
<p>        <strong>if</strong> (config.BSSID != <strong>null</strong> &amp;&amp; <br />
                !mWifiStateTracker.setNetworkVariable( <br />
                    netId, <br />
                    WifiConfiguration.bssidVarName, <br />
                    config.BSSID)) { <br />
            <strong>if</strong> (DBG) { <br />
                Slog.d(TAG, "failed to set BSSID: "+config.BSSID); <br />
            } <br />
            <strong>break</strong> setVariables; <br />
        }</p>
<p>我们来到frameworks/base/wifi/java/android/net/wifi/WifiStateTracker.java中，看看addNetwork和setNetworkVariable函数都是什么样的。</p>
<p><em>/**</em> <br /><em>* Add a network</em> <br /><em>*</em> <br /><em>* @return network id of the new network</em> <br /><em>*/</em> <br /><strong>public</strong> <strong>synchronized</strong> <strong>int</strong> addNetwork() { <br />
    <strong>if</strong> (mWifiState.get() != WIFI_STATE_ENABLED) { <br />
        <strong>return</strong> -1; <br />
    } <br />
    <strong>return</strong> WifiNative.addNetworkCommand(); <br />
} </p>
<p><em>/**</em> <br /><em>* Set network setting by name</em> <br /><em>*</em> <br /><em>* @param netId network id of the network</em> <br /><em>* @param name network variable key</em> <br /><em>* @param value network variable value</em> <br /><em>* @return {@code true} if the operation succeeds, {@code false} otherwise</em> <br /><em>*/</em> <br /><strong>public</strong> <strong>synchronized</strong> <strong>boolean</strong> setNetworkVariable(<strong>int</strong> netId,String name, String value) { <br />
    <strong>if</strong> (mWifiState.get() != WIFI_STATE_ENABLED) { <br />
        <strong>return</strong> <strong>false</strong>; <br />
    } <br />
    <strong>return</strong> WifiNative.setNetworkVariableCommand(netId, name,value); <br />
} </p>
<p>似乎WifiNative就应该是最终boss了，于是来到frameworks/base/wifi/java/android/net/wifi/WifiNative.java中一看，这两个函数都是这么定义的。</p>
<p> </p>
<p><strong>public</strong> <strong>native</strong> <strong>static</strong> <strong>int</strong> addNetworkCommand(); </p>
<p><strong>public</strong> <strong>native</strong> <strong>static</strong> <strong>boolean</strong> setNetworkVariableCommand(<strong>int</strong>netId, String name, String value); </p>
<p> </p>
<p>熟悉Android NDK开发的朋友都应该知道，这里的函数都是通过jni链接到c/c++代码中，于是我们稍微花了一点时间，找到了这个函数所对应的frameworks/base/core/jni/android_net_wifi_Wifi.cpp</p>
<p> </p>
<p><strong>static</strong> <strong>int</strong> doCommand(<strong>const</strong> <strong>char</strong> *cmd, <strong>char</strong> *replybuf, <strong>int</strong>replybuflen) <br />
{ <br />
    <strong>size_t</strong> reply_len = replybuflen - 1; </p>
<p>    <strong>if</strong> (::wifi_command(cmd, replybuf, &amp;reply_len) != 0) <br />
        <strong>return</strong> -1; <br />
    <strong>else</strong> { <br />
        <em>// Strip off trailing newline</em> <br />
        <strong>if</strong> (reply_len &gt; 0 &amp;&amp; replybuf[reply_len-1] == '\n') <br />
            replybuf[reply_len-1] = '\0'; <br />
        <strong>else</strong> <br />
            replybuf[reply_len] = '\0'; <br />
        <strong>return</strong> 0; <br />
    } <br />
} </p>
<p><strong>static</strong> jint doIntCommand(<strong>const</strong> <strong>char</strong> *cmd) <br />
{ <br />
    <strong>char</strong> reply[256]; </p>
<p>    <strong>if</strong> (doCommand(cmd, reply, <strong>sizeof</strong>(reply)) != 0) { <br />
        <strong>return</strong> (jint)-1; <br />
    } <strong>else</strong> { <br />
        <strong>return</strong> (jint)atoi(reply); <br />
    } <br />
} </p>
<p><strong>static</strong> jboolean doBooleanCommand(<strong>const</strong> <strong>char</strong> *cmd, <strong>const</strong> <strong>char</strong>*expect) <br />
{ <br />
    <strong>char</strong> reply[256]; </p>
<p>    <strong>if</strong> (doCommand(cmd, reply, <strong>sizeof</strong>(reply)) != 0) { <br />
        <strong>return</strong> (jboolean)JNI_FALSE; <br />
    } <strong>else</strong> { <br />
        <strong>return</strong> (jboolean)(strcmp(reply, expect) == 0); <br />
    } <br />
} </p>
<p>…… </p>
<p><strong>static</strong> jint android_net_wifi_addNetworkCommand(JNIEnv* env,jobject clazz) <br />
{ <br />
    <strong>return</strong> doIntCommand("ADD_NETWORK"); <br />
} </p>
<p><strong>static</strong> jbooleanandroid_net_wifi_setNetworkVariableCommand(JNIEnv* env, <br />
                                                          jobject clazz, <br />
                                                          jint netId, <br />
                                                          jstring name, <br />
                                                          jstring value) <br />
{ <br />
    <strong>char</strong> cmdstr[256]; <br />
    jboolean isCopy; </p>
<p>    <strong>const</strong> <strong>char</strong> *nameStr = env-&gt;GetStringUTFChars(name,&amp;isCopy); <br />
    <strong>const</strong> <strong>char</strong> *valueStr = env-&gt;GetStringUTFChars(value,&amp;isCopy); </p>
<p>    <strong>if</strong> (nameStr == NULL || valueStr == NULL) <br />
        <strong>return</strong> JNI_FALSE; </p>
<p>    <strong>int</strong> cmdTooLong = snprintf(cmdstr, <strong>sizeof</strong>(cmdstr),"SET_NETWORK %d %s %s", <br />
                 netId, nameStr, valueStr) &gt;=(<strong>int</strong>)<strong>sizeof</strong>(cmdstr); </p>
<p>    env-&gt;ReleaseStringUTFChars(name, nameStr); <br />
    env-&gt;ReleaseStringUTFChars(value, valueStr); </p>
<p>    <strong>return</strong> (jboolean)!cmdTooLong &amp;&amp; doBooleanCommand(cmdstr,"OK"); <br />
} </p>
<p>…… </p>
<p><em>// ----------------------------------------------------------------------------</em> </p>
<p><em>/*</em> <br /><em>* JNI registration.</em> <br /><em>*/</em> <br /><strong>static</strong> JNINativeMethod gWifiMethods[] = { <br />
    <em>/* name, signature, funcPtr */</em> </p>
<p>    { "loadDriver", "()Z",  (<strong>void</strong>*)android_net_wifi_loadDriver }, <br />
    { "unloadDriver", "()Z",  (<strong>void</strong>*)android_net_wifi_unloadDriver }, <br />
    { "startSupplicant", "()Z",  (<strong>void</strong>*)android_net_wifi_startSupplicant }, <br />
    { "stopSupplicant", "()Z",  (<strong>void</strong>*)android_net_wifi_stopSupplicant }, <br />
    { "connectToSupplicant", "()Z",  (<strong>void</strong>*)android_net_wifi_connectToSupplicant }, <br />
    { "closeSupplicantConnection", "()V",  (<strong>void</strong>*)android_net_wifi_closeSupplicantConnection }, </p>
<p>    { "listNetworksCommand", "()Ljava/lang/String;", <br />
        (<strong>void</strong>*) android_net_wifi_listNetworksCommand }, <br />
    { "addNetworkCommand", "()I", (<strong>void</strong>*)android_net_wifi_addNetworkCommand }, <br />
    { "setNetworkVariableCommand", "(ILjava/lang/String;Ljava/lang/String;)Z", <br />
        (<strong>void</strong>*) android_net_wifi_setNetworkVariableCommand}, <br />
    { "getNetworkVariableCommand", "(ILjava/lang/String;)Ljava/lang/String;", <br />
        (<strong>void</strong>*) android_net_wifi_getNetworkVariableCommand}, <br />…… </p>
<p> </p>
<p>看来这下终于找到干活儿的函数了，可喜可贺，于是我们得出结论：在Android中，要连上一个无线网络，首先需要添加一个网络，然后设置这个网络的配置，而这些步骤实际上都是通过向wpa_supplicant发送命令实现的。命令的格式例外的很简单，比如添加一个网络配置是ADD_NETWORK，设置一个网络配置是SET_NETWORK [netId] [varName] [var]。于是根据Java代码我写出了配置环节的代码。</p>
<p><strong>int</strong> config_stage(){    <br />
    <em>// Add a network config to supplicant mode</em> <br />
    <strong>int</strong> networkId = doIntCommand("ADD_NETWORK"); <em>// Add a new network id</em> <br />
    <strong>if</strong>(networkId &lt; 0) { <br />
        LOGE("Failed to add a network configuration. %s",strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    } </p>
<p>    LOGE("Add a network %d",networkId); </p>
<p>    <em>// set the ssid of the destination wifi adhoc</em> <br />
    <strong>char</strong> cmdstr[256]; <br />
    snprintf(cmdstr, <strong>sizeof</strong>(cmdstr), "SET_NETWORK %d %s %s",networkId, SSID_NAME, SSID); <br />
    <strong>if</strong>(!doBooleanCommand(cmdstr,"OK")) { <br />
        LOGE("Failed to set network %d configuration ssid. %s", networkId, strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    } </p>
<p>    <strong>return</strong> networkId; <br />
} </p>
<p>添加了一个配置的网络之后，选择某个网络配置的命令是SELECT_NETWORK [netId]。在SELECT_NETWORK之后，wpa_supplicant就尝试和该ssid的AP进行associate操作，在associate之后便调用dhcpd获取ip。SELECT_NETWORK是立即返回的函数，那么何以得知已经和无线AP连接上了呢？Android的界面里面连接/断开Wifi都是可以被接受到的事件，在WifiStateTracker中我们看到是由WifiMonitor来监听由wpa_supplicant发过来的消息的，于是我们来到framework/base/wifi/java/android/net/wifi/WifiMonitor.java，看到其中接受消息的Monitor线程</p>
<p> </p>
<p><strong>class</strong> MonitorThread <strong>extends</strong> Thread { <br />
    <strong>public</strong> MonitorThread() { <br />
        <strong>super</strong>("WifiMonitor"); <br />
    } </p>
<p>    <strong>public</strong> <strong>void</strong> run() { </p>
<p>        <strong>if</strong> (connectToSupplicant()) { <br />
            <em>// Send a message indicating that it is now possible to send commands</em> <br />
            <em>// to the supplicant</em> <br />
            mWifiStateTracker.notifySupplicantConnection(); <br />
        } <strong>else</strong> { <br />
            mWifiStateTracker.notifySupplicantLost(); <br />
            <strong>return</strong>; <br />
        } </p>
<p>        <em>//noinspection InfiniteLoopStatement</em> <br />
        <strong>for</strong> (;;) { <br />
            String eventStr = WifiNative.waitForEvent(); </p>
<p>            <em>// Skip logging the common but mostly uninteresting scan-results event</em> <br />
            <strong>if</strong> (Config.LOGD &amp;&amp;eventStr.indexOf(scanResultsEvent) == -1) { <br />
                Log.v(TAG, "Event [" + eventStr + "]"); <br />
            } <br />
            <strong>if</strong> (!eventStr.startsWith(eventPrefix)) { <br />
                <strong>if</strong> (eventStr.startsWith(wpaEventPrefix) &amp;&amp; <br />
                        0 &lt;eventStr.indexOf(passwordKeyMayBeIncorrectEvent)) { <br />
                    handlePasswordKeyMayBeIncorrect(); <br />
                } <br />
                <strong>continue</strong>; <br />
            } </p>
<p>            String eventName =eventStr.substring(eventPrefixLen); <br />
            <strong>int</strong> nameEnd = eventName.indexOf(' '); <br />
            <strong>if</strong> (nameEnd != -1) <br />
                eventName = eventName.substring(0, nameEnd);<br />
            <strong>if</strong> (eventName.length() == 0) { <br />
                <strong>if</strong> (Config.LOGD) Log.i(TAG, "Received wpa_supplicant event with empty event<br />
 name"); </p>
<p> </p>
<p> </p>
<p>WifiNative.wairForEvent在wifi.c中对应的函数是wifi_wait_event()，用来阻塞的等待wpa_supplicant发来的消息。当wpa_supplicant连接上之后，便会发出一个CONTROL-EVENT-CONNECTED的消息，只要截获这个消息，我们便可以进行dhcp的操作了。</p>
<p>基于以上的考虑，我写了connect阶段的代码。这里我偷了一下懒，没有仔细的去分析过来的命令，只是匹配到有CONNECTED的命令，就当已经连接上了。</p>
<p>#define CONNECTED "CONNECTED" <br /><strong>int</strong> connect_stage(<strong>int</strong> networkId) { <br />
    <strong>char</strong> cmdstr[256]; <br />
    <em>// enable the network</em> <br />
    snprintf(cmdstr, <strong>sizeof</strong>(cmdstr), "SELECT_NETWORK<br />
 %d",networkId); <br />
    <strong>if</strong>(!doBooleanCommand(cmdstr,"OK")) { <br />
        LOGE("Failed to select network %d. %s", networkId, strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    } </p>
<p>    <em>// wait for connect</em> <br />
    <strong>char</strong> buf[256]; <br />
    <strong>while</strong>(1) { <br />
        <strong>int</strong> nread = wifi_wait_for_event(buf, <strong>sizeof</strong>(buf)); <br />
        <strong>if</strong>(nread &gt; 0) { <br />
            LOGE("receive buf:\n %s\n",buf); <br />
            <strong>if</strong>(strstr(buf,CONNECTED) &gt; 0) { <br />
                <strong>break</strong>; <br />
            } <br />
            <em>// XXX danger of not going out of the loop!!!</em> <br />
        } <br />
        <strong>continue</strong>; <br />
    } <br />
    <strong>return</strong> 0; <br />}</p>
<p>在WifiStateTracer中我还找到了负责dhcp的DhcpHandler，按照其中的函数写了dhcp阶段的代码</p>
<p><strong>int</strong> dhcp_stage(){ <br />    <strong>int</strong> result; <br />    in_addr_t ipaddr, gateway, mask, dns1, dns2, server; <br />    <strong>uint32_t</strong> lease; </p>
<p>    <strong>char</strong> ifname[256]; <br />    <strong>char</strong> mDns1Name[256]; <br />    <strong>char</strong> mDns2Name[256]; <br />    property_get("wifi.interface", ifname ,"eth0"); <br />    snprintf(mDns1Name, <strong>sizeof</strong>(mDns1Name), "net.%s.dns1",ifname); <br />    snprintf(mDns2Name, <strong>sizeof</strong>(mDns2Name), "net.%s.dns2",ifname); </p>
<p>    result = dhcp_do_request(ifname, &amp;ipaddr, &amp;gateway, &amp;mask, &amp;dns1,&amp;dns2, &amp;server, &amp;lease); <br />    <strong>if</strong>(result != 0) { <br />        LOGE("Failed<br />
 to dhcp on interface %s. %s", ifname, strerror(errno)); <br />        <strong>return</strong> -1; <br />    } <br />    <strong>struct</strong> in_addr dns_struct1, dns_struct2; <br />    dns_struct1.s_addr = dns1; <br />    dns_struct2.s_addr = dns2; <br />    property_set(mDns1Name,inet_ntoa(dns_struct1)); <br />    property_set(mDns2Name,inet_ntoa(dns_struct2)); <br />    <strong>return</strong> 0; <br />} </p>
<p>于是我用无线路由器建立了一个最简单的无线网络，ssid=TSever，没有密码，按照上面步骤进行联网。结果在ADD_NETWORK的步骤就出错了，无法获得网络id，这是怎么一回事呢？看到dhcp时的代码要对特定的Network Interface做操作，突然想起来之前在代码中似乎看到有对Interface做使能操作的代码——WifiService在调用mWifiStateTracker.enableNetwork之前，还调用了String ifname = mWifiStateTracker.getInterfaceName();<br />
 NetworkUtils.enableInterface(ifname);这两句。于是在init阶段，加上了下面这段。</p>
<p>    <strong>char</strong> ifname[256]; <br />
    property_get("wifi.interface", ifname ,"eth0"); <br />
    ret = ifc_enable(ifname); <br />
    <strong>if</strong>(ret &lt; 0) { <br />
        LOGE("Failed to enable wifi interface %s. %s", ifname ,strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    }</p>
<p>但是运行起来还是出同样的错误，不过这次busybox ifconfig之后可以发现eth0的端口了 ，至少没有做无用功。倒回去看在WifiMonitor的MonitorThread中有connectToSupplicant()的调用，本以为此调用不是非常关键，然后去hardware/libhardware_legacy/wifi/wifi.c文件里面看到全局有一个static struct wpa_ctrl *ctrl_conn;并且在wifi_command中需要用到这个ctrl_conn，那么如果这个ctrl_conn是NULL的话，所有的wifi_command命令自然都无法完成了，于是又加上了</p>
<p>ret = wifi_connect_to_supplicant(); <br />    <strong>if</strong>(ret &lt; 0) { <br />        LOGE("Failed<br />
 to connect supplicant daemon. %s",strerror(errno)); <br />        <strong>return</strong> -1; <br />    } </p>
<p>这样编译完运行之后，果然顺利的分配到id了。运行一下程序，还是出现了错误，输出的log如下。</p>
<p>I/wpa_supplicant(  618): CTRL-EVENT-SCAN-RESULTS  Ready<br />
I/wpa_supplicant(  618): Trying to associate with 00:24:b2:c1:16:b6 (SSID='TServer' freq=2462 MHz)<br />
I/wpa_supplicant(  618): CTRL-EVENT-STATE-CHANGE id=-1 state=3<br />
E/        (  612): Finished init stage.<br />
E/        (  612): Add a network 2<br />
E/        (  612): Finished config stage.<br />
I/wpa_supplicant(  618): CTRL-EVENT-STATE-CHANGE id=1 state=0<br />
E/        (  612): receive buf:<br />
E/        (  612):  CTRL-EVENT-STATE-CHANGE id=1 state=0<br />
I/wpa_supplicant(  618): CTRL-EVENT-STATE-CHANGE id=-1 state=2<br />
E/        (  612): receive buf:<br />
E/        (  612):  CTRL-EVENT-STATE-CHANGE id=-1 state=2<br />
I/wpa_supplicant(  618): CTRL-EVENT-SCAN-RESULTS  Ready<br />
E/        (  612): receive buf:<br />
E/        (  612):  CTRL-EVENT-SCAN-RESULTS  Ready<br />
I/wpa_supplicant(  618): CTRL-EVENT-STATE-CHANGE id=-1 state=4<br />
E/        (  612): receive buf:<br />
E/        (  612):  CTRL-EVENT-STATE-CHANGE id=-1 state=4<br />
I/wpa_supplicant(  618): Associated with 00:24:b2:c1:16:b6<br />
E/        (  612): receive buf:<br />
E/        (  612):  Associated with 00:24:b2:c1:16:b6<br />
I/wpa_supplicant(  618): CTRL-EVENT-SCAN-RESULTS  Ready<br />
E/        (  612): receive buf:<br />
E/        (  612):  CTRL-EVENT-SCAN-RESULTS  Ready<br />
D/NetworkLocationProvider(  127): onCellLocationChanged [4517,30785]<br />I/wpa_supplicant(  618): Authentication with 00:24:b2:c1:16:b6 timed out.<br />
E/        (  612): receive buf:<br />
E/        (  612):  Authentication with 00:24:b2:c1:16:b6 timed out.</p>
<p> </p>
<p>注意到红色的那句log，我的wifi并没有设置密码，为什么还需要Authentication呢？想一想是不是wpa_supplicant的限制，于是去网上搜了到了这篇<a href="http://blog.chinaunix.net/u3/97568/showart_2026559.html" rel="external nofollow noreferrer">wpa_supplicant<br />
 工具使用</a>，发现没有密码的情况下应该是这样的配置</p>
<pre># 明文连接方式（不使用WPA和IEEE802.1X）
network={
  ssid="plaintext-test"
  key_mgmt=NONE
}</pre>
<pre>于是在config阶段加上了对key_mgmt的设置，这下就连上了Wifi了，正确的log如下</pre>
<p>bash-4.1# wificonnect<br />
I/wpa_supplicant(  871): CTRL-EVENT-SCAN-RESULTS  Ready<br />
I/wpa_supplicant(  871): Trying to associate with 00:24:b2:c1:16:b6 (SSID='TServer' freq=2462 MHz)<br />
I/wpa_supplicant(  871): CTRL-EVENT-STATE-CHANGE id=-1 state=3<br />
E/        (  865): Finished init stage.<br />
E/        (  865): Add a network 2<br />
E/        (  865): Finished config stage.<br />
I/wpa_supplicant(  871): CTRL-EVENT-STATE-CHANGE id=1 state=0<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-STATE-CHANGE id=1 state=0<br />
I/wpa_supplicant(  871): CTRL-EVENT-STATE-CHANGE id=-1 state=2<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-STATE-CHANGE id=-1 state=2<br />
I/wpa_supplicant(  871): CTRL-EVENT-SCAN-RESULTS  Ready<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-SCAN-RESULTS  Ready<br />
I/wpa_supplicant(  871): Trying to associate with 00:24:b2:c1:16:b6 (SSID='TServer' freq=2462 MHz)<br />
E/        (  865): receive buf:<br />
E/        (  865):  Trying to associate with 00:24:b2:c1:16:b6 (SSID='TServer' freq=2462 MHz)<br />
I/wpa_supplicant(  871): CTRL-EVENT-STATE-CHANGE id=-1 state=3<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-STATE-CHANGE id=-1 state=3<br />
I/wpa_supplicant(  871): CTRL-EVENT-STATE-CHANGE id=2 state=4<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-STATE-CHANGE id=2 state=4<br />
I/wpa_supplicant(  871): Associated with 00:24:b2:c1:16:b6<br />
I/wpa_supplicant(  871): CTRL-EVENT-STATE-CHANGE id=2 state=7<br />
I/wpa_supplicant(  871): CTRL-EVENT-CONNECTED - Connection to 00:24:b2:c1:16:b6 completed (auth) [id=2 id_str=]<br />
E/        (  865): receive buf:<br />
E/        (  865):  Associated with 00:24:b2:c1:16:b6<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-STATE-CHANGE id=2 state=7<br />
E/        (  865): receive buf:<br />
E/        (  865):  CTRL-EVENT-CONNECTED - Connection to 00:24:b2:c1:16:b6 completed (auth) [id=2 id_str=]<br />
E/        (  865): Finished dhcp stage.</p>
<pre> </pre>
<pre>Android下实现非启动界面Wifi连接就算是完成了，以上工作是在界面启动并且Wifi设置关闭的情况下进行的，但和在没有界面的时候应该差别不大，下面是程序的源代码</pre>
<pre><em>/* </em>
<em>**</em>
<em>** Copyright 2006, The Android Open Source Project</em>
<em>**</em>
<em>** Licensed under the Apache License, Version 2.0 (the "License");</em>
<em>** you may not use this file except in compliance with the License.</em>
<em>** You may obtain a copy of the License at</em>
<em>**</em>
<em>**     http://www.apache.org/licenses/LICENSE-2.0</em>
<em>**</em>
<em>** Unless required by applicable law or agreed to in writing, software</em>
<em>** distributed under the License is distributed on an "AS IS" BASIS,</em>
<em>** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<em>** See the License for the specific language governing permissions and</em>
<em>** limitations under the License.</em>
<em>*/</em> 

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;unistd.h&gt;
#include &lt;errno.h&gt;
#include "string.h"
#include "hardware_legacy/wifi.h"
#include "cutils/log.h"
#include "cutils/properties.h"
#include &lt;arpa/inet.h&gt;
#include &lt;netutils/ifc.h&gt;
#include &lt;netutils/dhcp.h&gt; 

<strong>static</strong> <strong>int</strong> doCommand(<strong>const</strong> <strong>char</strong> *cmd, <strong>char</strong> *replybuf, <strong>int</strong> replybuflen)
{
    <strong>size_t</strong> reply_len = replybuflen - 1; 

    <strong>if</strong> (wifi_command(cmd, replybuf, &amp;reply_len) != 0)
        <strong>return</strong> -1;
    <strong>else</strong> {
        <em>// Strip off trailing newline</em>
        <strong>if</strong> (reply_len &gt; 0 &amp;&amp; replybuf[reply_len-1] == '\n')
            replybuf[reply_len-1] = '\0';
        <strong>else</strong>
            replybuf[reply_len] = '\0';
        <strong>return</strong> 0;
    }
} 

<strong>static</strong> <strong>int</strong> doIntCommand(<strong>const</strong> <strong>char</strong> *cmd)
{
    <strong>char</strong> reply[256]; 

    <strong>if</strong> (doCommand(cmd, reply, <strong>sizeof</strong>(reply)) != 0) {
        <strong>return</strong> -1;
    } <strong>else</strong> {
        <strong>return</strong> atoi(reply);
    }
} 

<strong>static</strong> <strong>int</strong> doBooleanCommand(<strong>const</strong> <strong>char</strong> *cmd, <strong>const</strong> <strong>char</strong> *expect)
{
    <strong>char</strong> reply[256]; 

    <strong>if</strong> (doCommand(cmd, reply, <strong>sizeof</strong>(reply)) != 0) {
        <strong>return</strong> 0;
    } <strong>else</strong> {
        <strong>return</strong> (strcmp(reply, expect) == 0);
    }
} 

<em>// Send a command to the supplicant, and return the reply as a String</em>
<strong>static</strong> <strong>char</strong>* doStringCommand(<strong>const</strong> <strong>char</strong> *cmd)
{
    <strong>char</strong> reply[4096]; 

    <strong>if</strong> (doCommand(cmd, reply, <strong>sizeof</strong>(reply)) != 0) {
        <strong>return</strong> NULL;
    } <strong>else</strong> {
        <strong>return</strong> reply;
    }
} 

<strong>int</strong> init_stage() {
    <em>// load the wifi driver: insmod .ko</em>
    <strong>int</strong> ret = wifi_load_driver();
    <strong>if</strong>(ret &lt; 0) {
        LOGE("Failed to load Wi-Fi driver. %s",strerror(errno));
        <strong>return</strong> -1;
    } 

    <em>// start wpa_supplicant</em>
    ret =  wifi_start_supplicant();
    <strong>if</strong>(ret &lt; 0) {
        LOGE("Failed to start supplicant daemon. %s",strerror(errno));
        <strong>return</strong> -1;
    } 

    ret = wifi_connect_to_supplicant();
    <strong>if</strong>(ret &lt; 0) {
        LOGE("Failed to connect supplicant daemon. %s",strerror(errno));
        <strong>return</strong> -1;
    } 

    <strong>char</strong> ifname[256];
    property_get("wifi.interface", ifname ,"eth0");
    ret = ifc_enable(ifname);
    <strong>if</strong>(ret &lt; 0) {
        LOGE("Failed to enable wifi interface %s. %s", ifname ,strerror(errno));
        <strong>return</strong> -1;
    } 

    <strong>return</strong> 0;
} 

<strong>int</strong> scan_stage(){
    <em>// XXX we don't need to really scan the wifi </em>
    <strong>return</strong> 0;
} 

#define SSID_NAME "ssid"
#define KEY_MGMT "key_mgmt"
#define SSID "\"xxxxx\""
#define PASS "NONE" 

<strong>int</strong> config_stage(){   
    <em>// Add a network config to supplicant mode</em>
    <strong>int</strong> networkId = doIntCommand("ADD_NETWORK"); <em>// Add a new network id</em>
    <strong>if</strong>(networkId &lt; 0) {
        LOGE("Failed to add a network configuration. %s",strerror(errno));
        <strong>return</strong> -1;
    } 

    LOGE("Add a network %d",networkId); 

    <em>// set the ssid of the destination wifi adhoc</em>
    <strong>char</strong> cmdstr[256];
    snprintf(cmdstr, <strong>sizeof</strong>(cmdstr), "SET_NETWORK %d %s %s",networkId, SSID_NAME, SSID);
    <strong>if</strong>(!doBooleanCommand(cmdstr,"OK")) {
        LOGE("Failed to set network %d configuration ssid. %s", networkId, strerror(errno));
        <strong>return</strong> -1;
    }
</pre>
<p>    snprintf(cmdstr, <strong>sizeof</strong>(cmdstr), "SET_NETWORK %d %s %s",networkId, KEY_MGMT ,PASS); <br />
    <strong>if</strong>(!doBooleanCommand(cmdstr,"OK")) { <br />
        LOGE("Failed to set network %d configuration key_mgmr. %s", networkId, strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    } </p>
<p>    <strong>return</strong> networkId; <br />
} </p>
<p>#define CONNECTED "CONNECTED" <br /><strong>int</strong> connect_stage(<strong>int</strong> networkId) { <br />
    <strong>char</strong> cmdstr[256]; <br />
    <em>// enable the network</em> <br />
    snprintf(cmdstr, <strong>sizeof</strong>(cmdstr), "SELECT_NETWORK %d",networkId); <br />
    <strong>if</strong>(!doBooleanCommand(cmdstr,"OK")) { <br />
        LOGE("Failed to select network %d. %s", networkId,strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    } </p>
<p>    <em>// wait for connect</em> <br />
    <strong>char</strong> buf[256]; <br />
    <strong>while</strong>(1) { <br />
        <strong>int</strong> nread = wifi_wait_for_event(buf, <strong>sizeof</strong>(buf)); <br />
        <strong>if</strong>(nread &gt; 0) { <br />
            LOGE("receive buf:\n %s\n",buf); <br />
            <strong>if</strong>(strstr(buf,CONNECTED) &gt; 0) { <br />
                <strong>break</strong>; <br />
            } <br />
            <em>// XXX danger of not going out of the loop!!!</em> <br />
        } <br />
        <strong>continue</strong>; <br />
    } <br />
    <strong>return</strong> 0; <br />
} </p>
<p><strong>int</strong> dhcp_stage(){ <br />
    <strong>int</strong> result; <br />
    in_addr_t ipaddr, gateway, mask, dns1, dns2, server; <br />
    <strong>uint32_t</strong> lease; </p>
<p>    <strong>char</strong> ifname[256]; <br />
    <strong>char</strong> mDns1Name[256]; <br />
    <strong>char</strong> mDns2Name[256]; <br />
    property_get("wifi.interface", ifname ,"eth0"); <br />
    snprintf(mDns1Name, <strong>sizeof</strong>(mDns1Name),"net.%s.dns1",ifname); <br />
    snprintf(mDns2Name, <strong>sizeof</strong>(mDns2Name),"net.%s.dns2",ifname); </p>
<p>    result = dhcp_do_request(ifname, &amp;ipaddr, &amp;gateway,&amp;mask, &amp;dns1, &amp;dns2, &amp;server, &amp;lease); <br />
    <strong>if</strong>(result != 0) { <br />
        LOGE("Failed to dhcp on interface %s. %s", ifname,strerror(errno)); <br />
        <strong>return</strong> -1; <br />
    } <br />
    <strong>struct</strong> in_addr dns_struct1, dns_struct2; <br />
    dns_struct1.s_addr = dns1; <br />
    dns_struct2.s_addr = dns2; <br />
    property_set(mDns1Name,inet_ntoa(dns_struct1)); <br />
    property_set(mDns2Name,inet_ntoa(dns_struct2)); <br />
    <strong>return</strong> 0; <br />
} </p>
<p><strong>int</strong> main(<strong>int</strong> argc, <strong>char</strong> *argv[]) <br />
{ <br />
    <strong>int</strong> ret = init_stage(); <br />
    <strong>if</strong>(ret &lt; 0) { <br />
        LOGE("Failed init stage. %s",strerror(errno)); <br />
        exit(-1); <br />
    } </p>
<p>    LOGE("Finished init stage."); </p>
<p>    ret = config_stage(); <br />
    <strong>if</strong>(ret &lt; 0) { <br />
        LOGE("Failed config stage. %s",strerror(errno)); <br />
        exit(-1); <br />
    } <br />
    LOGE("Finished config stage."); </p>
<p>    ret = connect_stage(ret); <br />
    <strong>if</strong>(ret &lt; 0) { <br />
        LOGE("Failed connect stage. %s",strerror(errno)); <br />
        exit(-1); <br />
    } <br />
    LOGV("Finished connect stage."); </p>
<p>    ret = dhcp_stage(); <br />
    <strong>if</strong>(ret &lt; 0) { <br />
        LOGE("Failed dhcp stage. %s",strerror(errno)); <br />
        exit(-1); <br />
    } <br />
    LOGE("Finished dhcp stage."); <br />
    <strong>return</strong> 0; <br />
} </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 13:59:46</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android下实现非启动界面Wifi连接的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8wl2b.html" rel="bookmark">详解Android中App的启动界面Splash的编写方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Splash界面的作用用来展现产品的Logo 应用程序初始化的操作 检查应用程序的版本 检查当前应用程序是否合法注册 二.界面的xml定义写一个布局背景设置为产品的logo图片,再添加一个textview显示版本号. &lt;TextView android:id=&quot;@+id/tv_splash_version&quot; android:layout_width=&quot;wrap_content&quot; android:layout_height=&quot;wrap_conten			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAk3AQz.html" rel="bookmark">浅析android下如何通过jni监控wifi网络连接、dhcpcd执行和power电源控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				libs/android_runtime/android_net_wifi_Wifi.cpp部分jni接口static JNINativeMethod gWifiMethods[] = {{ &quot;loadDriver&quot;, &quot;()Z&quot;, (void *)android_net_wifi_loadDriver },{ &quot;setPowerModeCommand&quot;, &quot;(I)Z&quot;, (void*) android_net_wifi_se			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP8K4lp.html" rel="bookmark">Skype for Android能通过3G或WiFi连接使用吗</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Skype for Android手机可以通过3G 或WiFi连接来拨打和接听Skype至Skype电话,拨打普通电话,使用在线号码(单独购买)接听电话以及收发即时消息.(美国除外,在美国,Skype至Skype通话及拨打普通电话只能通过WiFi连接).通过3G网络连接进行的Skype至Skype通话是免费的.如果是通过一个3G或WiFi移动数据套餐连接来使用Skype,运营商可能会收取数据流量费.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM1lr5b.html" rel="bookmark">Android配置----小米手机通过wifi连接ADB调试Android应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  [正文] ADB远程调试的方法给Android开发人员带来了便利,下面介绍本人亲测有效的wifi连接ADB的方法.首先要保证电脑和手机在同一个局域网内,并且手机要通过wifi已正常连接. [测试版本] 手机型号:小米2S 系统版本:MIUI 4.6.27(开发版) 1.手机的设置: (1)保证手机已经获得ROOT权限(MIUI稳定版无法获得ROOT权限,即使通过第三方实现,对手机也会造成一定的伤害,此时可将MIUI系统升级到开发版) (2)打开手机&quot;USB调试&quot;. 在[设置]→[全			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2GY5p.html" rel="bookmark">CentOS6&period;8下非图形界面如何配置IP&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  CentOS6.8下非图形界面如何配置IP?          操作提示: 将输入定向到虚拟机中时,在虚拟机内部单击或者按Ctrl+G; 将输入定向到物理主机时,按Ctrl+Alt. 1 安装CentOS6.8系统 2 查看IP配置信息 输入命令行:ifconfig,即可得到如图1所示系统已有的IP配置信息. 图1 系统已有的IP配置信息 从图1中可以看到,IP配置信息中并没有显示网卡设备eth0的基本信息. 3 查看系统是否存在网卡设备eth0 输入命令:ls /ect/sysconfig			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm7jKjb.html" rel="bookmark">视窗下MySQL的启动和连接&lpar;图文&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.查看并启动MySQL服务. 在Windows XP下安装完MySQL后,它就已经自动启动服务了,并且在开始菜单中有其客户端的快捷方式连接,见图4.1. 图4.1 可以通过Windows的服务管理器查看.&quot;开始&quot;-&quot;运行&quot;,输入&quot;services.msc&quot;,回车.弹出Windows的服务管理器,然后就可以看见服务名为&quot;mysql&quot;的服务项了,其右边标明&quot;已启动&quot;,见图4.2. 图4.2 如果没有&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmGve5b.html" rel="bookmark">Android 个人理财工具一：项目概述与启动界面的实现&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        从本文开始为大家制作一个Android个人理财工具,并把整个开发过程记录下来,与大家分享.        项目总体介绍        此Android个人理财工具的主要功能是,可以录入日常生活中的各类收入和支出明细,并且可以在每月底能够统计每月各类情况.给出收支关系饼图,月份之间的柱状图等报告.        下图是程序的流程图:        程序可能涉及到的技术:        1.多个视图的切换,参数的传递,intent的使用.        2.Grid 明细的体现.  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7YLB5M.html" rel="bookmark">Android下RTL8192cu WiFi模块的移植</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android下RTL8192cu WiFi模块的移植 本人用的友善之臂的tiny210开发板,想要在Android4.0系统下移植WiFi热点功能,所用的WiFi模块是USB接口的RTL8192CU模块.移植过程中,realtek技术文档说如果要使用nl80211接口的话,需要在驱动autoconf.h头文件中定义宏CONFIG_IOCTL_CFG80211,但是定义该宏变量后,系统每次加载该驱动时就会报错并自动重启. 报错结果如下: 然而,如果不定义该宏变量,驱动虽然正确加载,但是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Z6VRp.html" rel="bookmark">app-androd H5混合开发 当无网络下，android怎么加载H5界面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 androd H5混合开发 当无网络下,android怎么加载H5界面 利用webview 套H5开发app,本人是实习生,有一下几个问题: 1.当无网络下,android怎么加载H5界面,不可能都把H5界面存放在本地吧,如果存放部分,怎么实现有网的时候进行替换. 2.怎么可以实现更好的自定义错误界面来替换自带的 解决方案 加载web页面就用webview组件,你可以捕获返回的网络错误码,自己跳转到其他页面 解决方案二: 首先你得对网络进行判断,初次有网进入的应用的时候就把内容缓存保存			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkG3wp.html" rel="bookmark" class="title">实现Win8无盘刷新和重置系统</a>
					<div>
						此方法不需要安装介质就能直接从系统环境和RE环境进行系统刷新和重置.Windows和Office保留激活状态,其中新刷新能保留文档和应用,重置则不. CustomRefresh.wim文件包含系统.系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLVQZb.html" rel="bookmark" class="title">难道做站就是为了钱？</a>
					<div>
						我是个新手,学做网页两年了,当初学的时候完全是出于爱好,因为我的专业是种草坪,1年前自己弄了个论坛玩,才开始真正接触这行,每天我都会为论坛的发展而操心,改风格,备份,设置版块,看着论坛越开越热闹,我很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zO70qz.html" rel="bookmark" class="title">如何判断关键词的优化价格</a>
					<div>
						大家好,我是虚实网站设计,最近有很多的客户问我网站优化的价格,开始的时候确实不太好判定,因为一直都在优化自己公司的网站,但是现在由于市的需要,没办法就只能做seo这块,开始的时候说实话,真的不太好判断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw60Wp.html" rel="bookmark" class="title">DELPHI DATASNAP 2010入门操作&lpar;2&rpar;不写一行代码，绿色三层我也行</a>
					<div>
						没有一行代码的三层,功能肯定非常的简单,但是,再简单,我们也三层了,学习一 个东西,需要从入门开始就有兴趣,如果入门就给吓怕了,哪么后来何来信心学习呢? 现在就让我们开始吧,不只是没有华丽的词语,而是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr26dp.html" rel="bookmark" class="title">javascript之DOM技术（二）</a>
					<div>
						一.样式编程 1.页面中的每一个元素都具有一个style对象,此对象管理元素的CSS样式.这是在IE4.0引入的,后来作为DOM标准被接受.使用方法: var oDiv=document.getEle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK5NmM.html" rel="bookmark" class="title">AI与PS结合制作漂亮的连写立体字</a>
					<div>
						教程过程看似很多,制作起来也不是那么复杂.作者使用AI的目的是要做出比较流畅的字体和简单的立体效果.如果PS熟练的话,全部可以在PS里面完成.   大致过程:先设立好想要的文字或图形,然后慢慢立体化, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b249Eqp.html" rel="bookmark" class="title">windows7 64位旗舰版系统重置ie浏览器设置的方法</a>
					<div>
						  1.打开IE浏览器,然后点击菜单栏上面的齿轮图标,选择&quot;Internet选项&quot;项; 2.接着在打开的Internet选项界面中,切换到&quot;高级&quot;选项卡下,然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG3k5p.html" rel="bookmark" class="title">win7及win8中如何用晃晃功能</a>
					<div>
						  有时候打开很多窗口,桌面上都是打开的窗口,还是真让人感觉一团乱.当然,我们可以一个个的关闭或者最小化那些暂时不用的窗口.有没有更快关闭那些暂时不用的窗口呢?答案是肯定的. windows vist ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o5G7b.html" rel="bookmark" class="title">iis 7-IIS运行时挂掉，数据库偶尔连接错误，可能的原因是什么？</a>
					<div>
						问题描述 IIS运行时挂掉,数据库偶尔连接错误,可能的原因是什么? 我们的平台在运行过程中出了两个错误,其中第一错误出现了三次,问题出现时我们立即查看数据库,发现数据库的访问是正常的:第二个错误连续出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN0y0M.html" rel="bookmark" class="title">Laravel 5框架学习之日期，Mutator 和 Scope&lowbar;php实例</a>
					<div>
						在我们前面的解决方案中,直接给 published_at 赋值为当前日期实际上是一个临时解决方案,我们需要设定发布日期,可能是未来2天后才发布,让我们修改这个问题. 首先修改控制器: public f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nw7az.html" rel="bookmark" class="title">&dollar;&lpar;&amp;quot&semi;&amp;quot&semi;&rpar;&period;click与onclick的区别示例介绍&lowbar;jquery</a>
					<div>
						Html代码 &lt;script type=&quot;text/javascript&quot;&gt; $(function(){ $(&quot;#btn4&quot;).click(func ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6N58XM.html" rel="bookmark" class="title">rails4 中使用分页的方法</a>
					<div>
						    以前老版本的rails中默认自带分页方法,不过从rails2.0开始就将内置的分页pagination对象移除了,改以第三方gem提供支持.要在新的rails里使用分页也是非常简单啦,首先安装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlrQmb.html" rel="bookmark" class="title">dll的概念 dll导出变量 函数 类</a>
					<div>
						1. DLL的概念 DLL(Dynamic Linkable Library),动态链接库,可以向程序提供一些函数.变量或类.这些可以直接拿来使用. 静态链接库与动态链接库的区别:   (1)静态链接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKR3oz.html" rel="bookmark" class="title">操作database TableMeta几点内容</a>
					<div>
						背景    今天早上,领导给了我一个任务:在老的系统运行中,DBA反馈说获取database TableMeta操作有点慢,让我分析下基于oracle driver驱动是否可以做下优化.由此引出了本文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZqXZp.html" rel="bookmark" class="title">wcf-WCF事务配置的问题，麻烦各位大大看下</a>
					<div>
						问题描述 WCF事务配置的问题,麻烦各位大大看下 各位大大~请教个问题~我在 用了basicHttpBinding的WorkFlowEngineBinding, 现在我在做wcf的事务,要配置tran ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0jP4M.html" rel="bookmark" class="title">恶意程序入侵数百台Mac电脑，苹果用户真的安全么？</a>
					<div>
						   雷锋网消息,日前网络安全公司 Synack 在调查时发现,一种叫做 FruitFly 恶意监控软件入侵了部分苹果用户的 Mac 电脑.该恶意监控软件能够截屏.记录按键.访问摄像头以及获取其他敏感 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRlw6b.html" rel="bookmark" class="title">腾讯的未来，新微信？还是新QQ？</a>
					<div>
						在5月6日,腾讯方面对外宣布了称将会对公司组织架构进行新一轮调整,并且在同时宣布成立微信事业群,同时撤销了原本由吴宵光掌舵的腾讯电商控股公司,而其中的实物电商业务将会并入京东,O2O业务并入微信事业群 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg5wRM.html" rel="bookmark" class="title">javascript-js解码，unicode，&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;amp&semi;&num;99om&amp;amp&semi;amp&semi;quot&semi;解码后为com</a>
					<div>
						问题描述 js解码,unicode,&quot;c s = s.replace(/&amp;#(d+)/g, function ($0, $1) { return String.fromCharCod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5R28Wz.html" rel="bookmark" class="title">apple watc-在Apple watch上打开印象笔记后，手机的进程里多了个灰色的</a>
					<div>
						问题描述 在Apple watch上打开印象笔记后,手机的进程里多了个灰色的 这个是干什么用的,要怎么实现这个效果呢.还有就是问下怎么通过代码传入手机号后进入下图的拨打电话的页面. 解决方案 这个是a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y1jxz.html" rel="bookmark" class="title">常见的JavaScript易错知识点整理</a>
					<div>
						前言 本文是我学习JavaScript过程中收集与整理的一些易错知识点,将分别从变量作用域,类型比较,this指向,函数参数,闭包问题及对象拷贝与赋值这6个方面进行由浅入深的介绍和讲解,其中也涉及了一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1rK8b.html" rel="bookmark" class="title">iPhone价值不菲 一吨可炼9盎司黄金</a>
					<div>
						在苹果被3.15晚会曝光之后,大家估计都知道,苹果售后都实行&quot;整机交换&quot;,为什么在其他手机维修的时候,哪里出错就维修哪里,而苹果为什么要实行&quot;整机交换&quot;?其实, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE418z.html" rel="bookmark" class="title">315晚会曝光银行人员出售客户个人信息，腾讯管家有建议</a>
					<div>
						2012年315晚会曝光了银行工作人员出售客户个人信息给犯罪分子,犯罪分子通过这些信息拼凑银行卡密码,准确率竟然高达20%,从而通过网银窃取了用户账户中的钱.腾讯手机管家提醒所有人都抓紧更改银行卡密码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j18Kp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;宅男女神&rdquo;叶梓萱《画皮世界》静态电影首曝</a>
					<div>
						中国软件资讯网4月12日消息 全球首款3D大型集群式网游&lt;http://www.aliyun.com/zixun/aggregation/6661.html&quot;&gt;画皮世界&gt;第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0GYrz.html" rel="bookmark" class="title">河南：5年内建成百亿元产值云计算及数据中心产业园区</a>
					<div>
						7月31日消息(李明)河南省通信管理局与洛阳市人民政府联合印发&lt;关于建设洛阳云计算和互联网数据中心产业园的意见&gt;&quot;下称&lt;意见&gt;&quot;,河南将大力发展云计算和互联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKq0J5p.html" rel="bookmark" class="title">利用Python爬取可用的代理IP&lowbar;python</a>
					<div>
						前言 就以最近发现的一个免费代理IP网站为例:http://www.xicidaili.com/nn/.在使用的时候发现很多IP都用不了. 所以用Python写了个脚本,该脚本可以把能用的代理IP检测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYL3Vb.html" rel="bookmark" class="title">优化php效率&comma;提高php性能的一些方法&lowbar;php技巧</a>
					<div>
						1.在可以用file_get_contents替代file.fopen.feof.fgets等系列方法的情况下,尽量用 file_get_contents,因为他的效率高得多!但是要注意file_ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJORN7b.html" rel="bookmark" class="title">jQuery实现Meizu魅族官方网站的导航菜单效果&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery实现Meizu魅族官方网站的导航菜单效果.分享给大家供大家参考.具体如下: 偶尔看到魅族官方网站,发现网站的导航菜单的效果很不错就扣下来,俩字:给力.鼠标放到菜单上,菜单的下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2gDmM.html" rel="bookmark" class="title">jquery动态调整div大小使其宽度始终为浏览器宽度&lowbar;jquery</a>
					<div>
						有时候我们需要设置宽度为整个浏览器宽度的div,当然我们可以使用相对布局的方式做到这一点,不过我们也可以用jquery来实现. 复制代码 代码如下: &lt;!doctype html&gt; &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlvDlp.html" rel="bookmark" class="title">javascript 学习笔记&lpar;onchange等&rpar;&lowbar;javascript技巧</a>
					<div>
						1.onchange 及其onpropertychange,oninput 在IE下可使用onpropertychangel立即触发监听, oninput 可以使用在FF下,但必须使用w3c推荐的ad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2VyOM.html" rel="bookmark" class="title">Twemoji的使用以及在textarea中的显示教程</a>
					<div>
						Twitter 公开了开源的其完整的 Emoji 表情图片.开发者可以去GitHub下载完整的表情库,并把这些表情加入到自己的应用或网页中. 这几天的聊天项目中正好用到,记录下来方便使用. 调用方式  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
